PipeWire 1.2.6

Loading...
Searching...
No Matches
Files | Data Structures | Macros
System
SPA » Support

I/O, clock, polling, timer, and signal interfaces More...

## Files
file | system.h
| `spa/support/system.h`

## Data Structures
struct | spa_system
struct | spa_poll_event
struct | spa_system_methods

## Macros
#define | SPA_TYPE_INTERFACE_System SPA_TYPE_INFO_INTERFACE_BASE "System"
| a collection of core system functions
#define | SPA_TYPE_INTERFACE_DataSystem SPA_TYPE_INFO_INTERFACE_BASE "DataSystem"
#define | SPA_VERSION_SYSTEM 0
#define | SPA_IO_IN (1 << 0)
#define | SPA_IO_OUT (1 << 2)
#define | SPA_IO_ERR (1 << 3)
#define | SPA_IO_HUP (1 << 4)
#define | SPA_FD_CLOEXEC (1<<0)
#define | SPA_FD_NONBLOCK (1<<1)
#define | SPA_FD_EVENT_SEMAPHORE (1<<2)
#define | SPA_FD_TIMER_ABSTIME (1<<3)
#define | SPA_FD_TIMER_CANCEL_ON_SET (1<<4)
#define | SPA_VERSION_SYSTEM_METHODS 0
#define | spa_system_method_r(o, method, version, ...)
#define | spa_system_read(s, ...)
#define | spa_system_write(s, ...)
#define | spa_system_ioctl(s, ...)
#define | spa_system_close(s, ...)
#define | spa_system_clock_gettime(s, ...)
#define | spa_system_clock_getres(s, ...)
#define | spa_system_pollfd_create(s, ...)
#define | spa_system_pollfd_add(s, ...)
#define | spa_system_pollfd_mod(s, ...)
#define | spa_system_pollfd_del(s, ...)
#define | spa_system_pollfd_wait(s, ...)
#define | spa_system_timerfd_create(s, ...)
#define | spa_system_timerfd_settime(s, ...)
#define | spa_system_timerfd_gettime(s, ...)
#define | spa_system_timerfd_read(s, ...)
#define | spa_system_eventfd_create(s, ...)
#define | spa_system_eventfd_write(s, ...)
#define | spa_system_eventfd_read(s, ...)
#define | spa_system_signalfd_create(s, ...)
#define | spa_system_signalfd_read(s, ...)

## Detailed Description

I/O, clock, polling, timer, and signal interfaces

## Macro Definition Documentation

## ◆ SPA_TYPE_INTERFACE_System

#define SPA_TYPE_INTERFACE_System SPA_TYPE_INFO_INTERFACE_BASE "System"

a collection of core system functions

Examples
  local-v4l2.c, spa/examples/adapter-control.c, spa/examples/example-control.c, spa/examples/local-libcamera.c, and spa/examples/local-v4l2.c.

## ◆ SPA_TYPE_INTERFACE_DataSystem

#define SPA_TYPE_INTERFACE_DataSystem SPA_TYPE_INFO_INTERFACE_BASE "DataSystem"

Examples
  spa/examples/adapter-control.c, and spa/examples/example-control.c.

## ◆ SPA_VERSION_SYSTEM

#define SPA_VERSION_SYSTEM 0

## ◆ SPA_IO_IN

#define SPA_IO_IN (1 << 0)

## ◆ SPA_IO_OUT

#define SPA_IO_OUT (1 << 2)

## ◆ SPA_IO_ERR

#define SPA_IO_ERR (1 << 3)

## ◆ SPA_IO_HUP

#define SPA_IO_HUP (1 << 4)

## ◆ SPA_FD_CLOEXEC

#define SPA_FD_CLOEXEC (1<<0)

## ◆ SPA_FD_NONBLOCK

#define SPA_FD_NONBLOCK (1<<1)

## ◆ SPA_FD_EVENT_SEMAPHORE

#define SPA_FD_EVENT_SEMAPHORE (1<<2)

## ◆ SPA_FD_TIMER_ABSTIME

#define SPA_FD_TIMER_ABSTIME (1<<3)

## ◆ SPA_FD_TIMER_CANCEL_ON_SET

#define SPA_FD_TIMER_CANCEL_ON_SET (1<<4)

## ◆ SPA_VERSION_SYSTEM_METHODS

#define SPA_VERSION_SYSTEM_METHODS 0

## ◆ spa_system_method_r

#define spa_system_method_r | ( |  | o,
|  |  | method,
|  |  | version,
|  |  | ... )

## ◆ spa_system_read

#define spa_system_read | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,read,0,__VA_ARGS__)
spa_system_method_r
#define spa_system_method_r(o, method, version,...)
Definition system.h:119

See also
  spa_system_methods.read

## ◆ spa_system_write

#define spa_system_write | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,write,0,__VA_ARGS__)

See also
  spa_system_methods.write

## ◆ spa_system_ioctl

#define spa_system_ioctl | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,ioctl,0,__VA_ARGS__)

See also
  spa_system_methods.ioctl

## ◆ spa_system_close

#define spa_system_close | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,close,0,__VA_ARGS__)

See also
  spa_system_methods.close

## ◆ spa_system_clock_gettime

#define spa_system_clock_gettime | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,clock_gettime,0,__VA_ARGS__)

See also
  spa_system_methods.clock_gettime

## ◆ spa_system_clock_getres

#define spa_system_clock_getres | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,clock_getres,0,__VA_ARGS__)

See also
  spa_system_methods.clock_getres

## ◆ spa_system_pollfd_create

#define spa_system_pollfd_create | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,pollfd_create,0,__VA_ARGS__)

See also
  spa_system_methods.pollfd_create

## ◆ spa_system_pollfd_add

#define spa_system_pollfd_add | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,pollfd_add,0,__VA_ARGS__)

See also
  spa_system_methods.pollfd_add

## ◆ spa_system_pollfd_mod

#define spa_system_pollfd_mod | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,pollfd_mod,0,__VA_ARGS__)

See also
  spa_system_methods.pollfd_mod

## ◆ spa_system_pollfd_del

#define spa_system_pollfd_del | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,pollfd_del,0,__VA_ARGS__)

See also
  spa_system_methods.pollfd_del

## ◆ spa_system_pollfd_wait

#define spa_system_pollfd_wait | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,pollfd_wait,0,__VA_ARGS__)

See also
  spa_system_methods.pollfd_wait

## ◆ spa_system_timerfd_create

#define spa_system_timerfd_create | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,timerfd_create,0,__VA_ARGS__)

See also
  spa_system_methods.timerfd_create

## ◆ spa_system_timerfd_settime

#define spa_system_timerfd_settime | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,timerfd_settime,0,__VA_ARGS__)

See also
  spa_system_methods.timerfd_settime

## ◆ spa_system_timerfd_gettime

#define spa_system_timerfd_gettime | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,timerfd_gettime,0,__VA_ARGS__)

See also
  spa_system_methods.timerfd_gettime

## ◆ spa_system_timerfd_read

#define spa_system_timerfd_read | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,timerfd_read,0,__VA_ARGS__)

See also
  spa_system_methods.timerfd_read

## ◆ spa_system_eventfd_create

#define spa_system_eventfd_create | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,eventfd_create,0,__VA_ARGS__)

See also
  spa_system_methods.eventfd_create

## ◆ spa_system_eventfd_write

#define spa_system_eventfd_write | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,eventfd_write,0,__VA_ARGS__)

See also
  spa_system_methods.eventfd_write

## ◆ spa_system_eventfd_read

#define spa_system_eventfd_read | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,eventfd_read,0,__VA_ARGS__)

See also
  spa_system_methods.eventfd_read

## ◆ spa_system_signalfd_create

#define spa_system_signalfd_create | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,signalfd_create,0,__VA_ARGS__)

See also
  spa_system_methods.signalfd_create

## ◆ spa_system_signalfd_read

#define spa_system_signalfd_read | ( |  | s,
|  |  | ... )

Value:
spa_system_method_r(s,signalfd_read,0,__VA_ARGS__)

See also
  spa_system_methods.signalfd_read